%undefine __brp_python_bytecompile

Summary:    list relationship from rpm packages
Name:       rpm-dep
Version:    6.0
Release:    2beta%{?dist}
License:    MIT
URL:        https://git.woa.com/tlinux/TSS-tools/depexplorer
Source0:    rpm-dep-%{version}.tar.gz
# default conf
Source1:    dep-repodata.conf

BuildRequires:  gcc python3-devel python3-rpm-macros pyproject-rpm-macros python3-wheel
BuildRequires:  python3-setuptools python3-pip systemd-rpm-macros
Requires:       redis python3-pyyaml python3-flask-restful python3-systemd python3-redis
Requires:       python3-rich python3-requests sed dnf rpm

%description
This package provides a tool to list relationship from rpm packages,
and output the relationship to grap, json, yaml files

%prep
%autosetup -n %{name}-%{version} -p1
find . -name arg_parser.py | xargs sed -i 's/ADJUSTABLE_VARIABLE/%{version}/g'

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install

find %{buildroot} \
    \( -type d -name "__pycache__" \
    -o -type f -name "*.py" \
    -o -type f -name "*.c" \) \
    -exec rm -rf {} +

install -Dp     %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}/dep-repodata.conf
install -Dpm644 service/rpm-depd.service %{buildroot}%{_unitdir}/rpm-depd.service
install -Dpm644 service/refresh-rpm-depd.service %{buildroot}%{_unitdir}/refresh-rpm-depd.service
install -Dpm644 service/refresh-rpm-depd.timer %{buildroot}%{_unitdir}/refresh-rpm-depd.timer
install -Dpm644 service/90-rpm-dep.preset %{buildroot}%{_prefix}/lib/systemd/system-preset/90-rpm-dep.preset
install -Dpm644 env/rpm-dep_env.sh %{buildroot}%{_sysconfdir}/profile.d/rpm-dep_env.sh

mkdir -p %{buildroot}%{_var}/%{name}/repodata

%post
%systemd_post rpm-depd.service
%systemd_post refresh-rpm-depd.timer

%preun
%systemd_preun rpm-depd.service
%systemd_preun refresh-rpm-depd.timer

%postun
%systemd_postun_with_restart rpm-depd.service
%systemd_postun_with_restart refresh-rpm-depd.timer

%files
%doc changelog README.md
%config(noreplace) %{_sysconfdir}/rpm-dep/dep-repodata.conf
%{_unitdir}/rpm-depd.service
%{_unitdir}/refresh-rpm-depd.service
%{_unitdir}/refresh-rpm-depd.timer
%{_prefix}/lib/systemd/system-preset/90-rpm-dep.preset
%{_sysconfdir}/profile.d/rpm-dep_env.sh
%{_bindir}/rpm-dep
%{_bindir}/rpm-depsym
%{_bindir}/rpm-depd
%{_bindir}/rpm-unfold
%{_bindir}/rpm-bundled
%{_bindir}/rpm-batch
%{_bindir}/rpm-hardep
%{_var}/%{name}/repodata
%{python3_sitearch}/*

%changelog
* Wed Jul 24 2024 Shuo Wang <abushwang@tencent.com> - 6.0-2
- update default dep-repodata.conf to mirrors.opencloudos

* Thu Jun 27 2024 Shuo Wang <abushwang@tencent.com> - 5.9-1
- update to 5.9
- add %config(noreplace)
- add preset

* Fri Jan 26 2024 Shuo Wang <abushwang@tencent.com> - 5.8-1
- update to 5.8:
- add rpm-hardep for strong reqs
- remove unused ci-rpm-dep

* Tue Dec 26 2023 Shuo Wang <abushwang@tencent.com> - 5.7-1
- update to 5.7:
- update sort algorithm to break cycle-deps for rpm-unfold
- add --mainpkgs / -M & --subpkgs / -S option for rpm-dep
- fix sub list missing for dotnet6.0

* Tue Dec 12 2023 Shuo Wang <abushwang@tencent.com> - 5.6-1
- update to 5.6

* Fri Nov 24 2023 Shuo Wang <abushwang@tencent.com> - 5.5-1
- update to 5.5 directly, there is too much updating

* Thu Nov 16 2023 Shuo Wang <abushwang@tencent.com> - 5.3-2
- backport fix --only-strong match fail

* Wed Nov 15 2023 Shuo Wang <abushwang@tencent.com> - 5.3-1
- update to 5.3
- add --only-strong option for rpm-dep

* Wed Nov 8 2023 Shuo Wang <abushwang@tencent.com> - 5.2-1
- update to 5.2
- rename rpm-depso to rpm-depsym
- add --requires/-r for rpm-dep and rpm-unfold

* Thu Nov 2 2023 Shuo Wang <abushwang@tencent.com> - 5.1-2
- add lock for other cli

* Tue Oct 31 2023 Shuo Wang <abushwang@tencent.com> - 5.1-1
- update to 5.1
- add support refresh-rpm-depd.service to update rpm-depd
- add rpm-bundled cli

* Fri Oct 27 2023 Shuo Wang <abushwang@tencent.com> - 5.0-1
- update to 5.0
- rpm-unfold adds --install/-i --build/-b --build_by/-B options
- rpm-dep removes src_build_by and bin_build_by options
- rpm-dep adds --src option
- rpm-depso optimization

* Wed Sep 27 2023 Shuo Wang <abushwang@tencent.com> - 4.6-1
- update to 4.6

* Fri Sep 1 2023 Shuo Wang <abushwang@tencent.com> - 4.5-1
- update to 4.5

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 4.4-1
- update to 4.4

* Fri Aug 18 2023 Shuo Wang <abushwang@tencent.com> - 4.3-2
- rpm-depd.service requires redis

* Fri Aug 4 2023 Shuo Wang <abushwang@tencent.com> - 4.3-1
- update to 4.3
- add support for rpm-depso
- add debug feature

* Tue Jul 25 2023 Shuo Wang <abushwang@tencent.com> - 4.2-1
- update to 4.2

* Thu Jul 20 2023 Shuo Wang <abushwang@tencent.com> - 4.1-3
- dsplaye requires to python3-requests

* Wed Jul 19 2023 Shuo Wang <abushwang@tencent.com> - 4.1-2
- backport many patch

* Tue Jul 18 2023 Shuo Wang <abushwang@tencent.com> - 4.1-1
- update to 4.1

* Mon Jul 17 2023 Shuo Wang <abushwang@tencent.com> - 4.0-2
- add line for generate_statistics

* Mon Jul 17 2023 Shuo Wang <abushwang@tencent.com> - 4.0-1
- update to 4.0

* Thu Jul 13 2023 Shuo Wang <abushwang@tencent.com> - 3.4-4
- fix circly dep

* Mon Jul 3 2023 Shuo Wang <abushwang@tencent.com> - 3.4-3
- add key src_name for yaml & json
- update rpm-dep version

* Mon Jul 3 2023 Shuo Wang <abushwang@tencent.com> - 3.4-2
- add suffix for outputfile
- replace -b to -B

* Wed Jun 28 2023 Shuo Wang <abushwang@tencent.com> - 3.4-1
- update to 3.4

* Tue Jun 27 2023 Shuo Wang <abushwang@tencent.com> - 3.0-1
- update to 3.0

* Wed Jun 21 2023 Shuo Wang <abushwang@tencent.com> - 2.0-1
- update to 2.0

* Fri Jun 9 2023 Shuo Wang <abushwang@tencent.com> - 1.0-2
- rename to rpm-dep

* Fri Jun 9 2023 Shuo Wang <abushwang@tencent.com> - 1.0-1
- initial build

